#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc BinMenu {} {
    global ds9

    menu $ds9(mb).bin
    $ds9(mb).bin add radiobutton -label [msgcat::mc {Average}] \
	-variable bin(function) -value average -command ChangeBinFunction
    $ds9(mb).bin add radiobutton -label [msgcat::mc {Sum}] \
	-variable bin(function) -value sum -command ChangeBinFunction
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label [msgcat::mc {Block In}] \
	-command {Bin .5 .5}
    $ds9(mb).bin add command -label [msgcat::mc {Block Out}] \
	-command {Bin 2 2}
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label [msgcat::mc {Block to Fit Frame}] \
	-command BinToFit
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 1" \
	-variable bin(factor) -value { 1 1 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 2" \
	-variable bin(factor) -value { 2 2 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 4" \
	-variable bin(factor) -value { 4 4 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 8" \
	-variable bin(factor) -value { 8 8 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 16" \
	-variable bin(factor) -value { 16 16 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 32" \
	-variable bin(factor) -value { 32 32 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 64" \
	-variable bin(factor) -value { 64 64 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 128" \
	-variable bin(factor) -value { 128 128 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 256" \
	-variable bin(factor) -value { 256 256 } -command ChangeBinFactor
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label {128x128} \
	-variable bin(buffersize) -value 128 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label {256x256} \
	-variable bin(buffersize) -value 256 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label {512x512} \
	-variable bin(buffersize) -value 512 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label {1024x1204} \
	-variable bin(buffersize) -value 1024 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label {2048x2048} \
	-variable bin(buffersize) -value 2048 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label {4096x4096} \
	-variable bin(buffersize) -value 4096 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label {8192x8192} \
	-variable bin(buffersize) -value 8192 -command ChangeBinBufferSize
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label "[msgcat::mc {Binning Parameters}]..." \
	-command BinDialog
}

proc PrefsDialogBin {} {
    global prefs

    set w $prefs(tabs)

    frame $w.bin
    $prefs(tabs) tab configure bin -window $w.bin -fill both

    frame $w.bin.menu -relief ridge -bd 1
    pack $w.bin.menu -side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.bin

    # Default Menu
    set f $w.bin.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Menu}]
    menubutton $f.bin -relief raised -text [msgcat::mc {Bin}] \
	-menu $f.bin.menu

    grid $f.title $f.bin -padx 4 -sticky w

    set m $f.bin.menu
    menu $m
    $m add radiobutton -label [msgcat::mc {Average}] \
	-variable pbin(function) -value average
    $m add radiobutton -label [msgcat::mc {Sum}] \
	-variable pbin(function) -value sum
    $m add separator
    $m add radiobutton -label "[msgcat::mc {Block}] 1" \
	-variable pbin(factor) -value { 1 1 }
    $m add radiobutton -label "[msgcat::mc {Block}] 2" \
	-variable pbin(factor) -value { 2 2 }
    $m add radiobutton -label "[msgcat::mc {Block}] 4" \
	-variable pbin(factor) -value { 4 4 }
    $m add radiobutton -label "[msgcat::mc {Block}] 8" \
	-variable pbin(factor) -value { 8 8 }
    $m add radiobutton -label "[msgcat::mc {Block}] 16" \
	-variable pbin(factor) -value { 16 16 }
    $m add radiobutton -label "[msgcat::mc {Block}] 32" \
	-variable pbin(factor) -value { 32 32 }
    $m add radiobutton -label "[msgcat::mc {Block}] 64" \
	-variable pbin(factor) -value { 64 64 }
    $m add radiobutton -label "[msgcat::mc {Block}] 128" \
	-variable pbin(factor) -value { 128 128 }
    $m add radiobutton -label "[msgcat::mc {Block}] 256" \
	-variable pbin(factor) -value { 256 256 }
    $m add separator
    $m add radiobutton -label {128x128} -variable pbin(buffersize) -value 128
    $m add radiobutton -label {256x256} -variable pbin(buffersize) -value 256
    $m add radiobutton -label {512x512} -variable pbin(buffersize) -value 512
    $m add radiobutton -label {1024x1204} -variable pbin(buffersize) -value 1024
    $m add radiobutton -label {2048x2048} -variable pbin(buffersize) -value 2048
    $m add radiobutton -label {4096x4096} -variable pbin(buffersize) -value 4096
    $m add radiobutton -label {8192x8192} -variable pbin(buffersize) -value 8192
}

proc BinButtons {} {
    global ds9

    frame $ds9(buttons).bin
    ButtonButton $ds9(buttons).bin.in {-} {Bin .5 .5}
    ButtonButton $ds9(buttons).bin.out {+} {Bin 2 2}
    ButtonButton $ds9(buttons).bin.tofit \
	[string tolower [msgcat::mc {To Fit}]] BinToFit
    RadioButton $ds9(buttons).bin.b1 \
	"[string tolower [msgcat::mc {Block}]] 1" \
	bin(factor) { 1 1 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b2 \
	"[string tolower [msgcat::mc {Block}]] 2" \
	bin(factor) { 2 2 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b4 \
	"[string tolower [msgcat::mc {Block}]] 4" \
	bin(factor) { 4 4 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b8 \
	"[string tolower [msgcat::mc {Block}]] 8" \
	bin(factor) { 8 8 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b16 \
	"[string tolower [msgcat::mc {Block}]] 16" \
	bin(factor) { 16 16 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b32 \
	"[string tolower [msgcat::mc {Block}]] 32" \
	bin(factor) { 32 32 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b64 \
	"[string tolower [msgcat::mc {Block}]] 64" \
	bin(factor) { 64 64 } ChangeBinFactor
}

proc UpdateBinMenu {} {
    global ds9
    global current
    global bin

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateBinMenu"
    }

    if {$current(frame) != {}} {
	if {[$current(frame) has fits]} {
	    if {[$current(frame) has fits bin]} {
		$ds9(mb) entryconfig [msgcat::mc {Bin}] -state normal
		$ds9(buttons).major.bin configure -state normal
	    } else {
		$ds9(mb) entryconfig [msgcat::mc {Bin}] -state disabled
		$ds9(buttons).major.bin configure -state disabled
	    }
	} else {
	    $ds9(mb) entryconfig [msgcat::mc {Bin}] -state normal
	    $ds9(buttons).major.bin configure -state normal
	}

	set bin(function) [$current(frame) get bin function]
	set bin(factor) "[$current(frame) get bin factor]"
	set bin(depth) [$current(frame) get bin depth]
	set bin(buffersize) [$current(frame) get bin buffer size]
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Bin}] -state disabled
	$ds9(buttons).major.bin configure -state disabled
    }
}

