#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc FrameMenu {} {
    global ds9

    # Frame Menu
    # WARNING: this is a variable length menu. Be sure to update frame.tcl

    menu $ds9(mb).frame
    $ds9(mb).frame add command -label [msgcat::mc {New Frame}] \
	-command CreateFrame
    $ds9(mb).frame add command -label [msgcat::mc {New Frame RGB}] \
	-command CreateRGBFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {Delete Frame}] \
	-command DeleteCurrentFrame
    $ds9(mb).frame add command -label [msgcat::mc {Delete All Frames}] \
	-command DeleteAllFramesMenu
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {Clear Frame}] \
	-command ClearCurrentFrame
    $ds9(mb).frame add command -label [msgcat::mc {Reset Frame}] \
	-command ResetCurrentFrame
    $ds9(mb).frame add command -label [msgcat::mc {Refresh Frame}] \
	-command UpdateCurrentFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add radiobutton -label [msgcat::mc {Single Frame}] \
	-variable ds9(display,user) -value single -command DisplayMode
    $ds9(mb).frame add radiobutton -label [msgcat::mc {Tile Frames}] \
	-variable ds9(display,user) -value tile -command DisplayMode
    $ds9(mb).frame add radiobutton -label [msgcat::mc {Blink Frames}] \
	-variable ds9(display,user) -value blink -command DisplayMode
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label [msgcat::mc {First Frame}] \
	-command FirstFrame
    $ds9(mb).frame add command -label [msgcat::mc {Previous Frame}] \
	-command PrevFrame
    $ds9(mb).frame add command -label [msgcat::mc {Next Frame}] \
	-command NextFrame
    $ds9(mb).frame add command -label [msgcat::mc {Last Frame}] \
	-command LastFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Tile}] \
	-menu $ds9(mb).frame.tile
    $ds9(mb).frame add cascade -label [msgcat::mc {Blink Interval}] \
	-menu $ds9(mb).frame.blink
    $ds9(mb).frame add command -label [msgcat::mc {Set Display Size}] \
	-command DisplayDefaultDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Match Frames}] \
	-menu $ds9(mb).frame.match
    $ds9(mb).frame add command -label [msgcat::mc {Match Colorbars}] \
	-command MatchColorbars
    $ds9(mb).frame add command -label [msgcat::mc {Match Scales}] \
	-command MatchScales
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Lock Crosshairs}] \
	-menu $ds9(mb).frame.crosshair
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label "[msgcat::mc {Data Cube}]..." \
	-command CubeDialog
    $ds9(mb).frame add command -label "[msgcat::mc {RGB}]..." \
	-command RGBDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label [msgcat::mc {Show/Hide Frames}] \
	-menu $ds9(mb).frame.active
    $ds9(mb).frame add separator

    menu $ds9(mb).frame.active
    $ds9(mb).frame.active add command -label [msgcat::mc {Show All}] \
	-command ActiveFrameAll
    $ds9(mb).frame.active add command -label [msgcat::mc {Hide All}] \
	-command ActiveFrameNone
    $ds9(mb).frame.active add separator

    menu $ds9(mb).frame.match
    $ds9(mb).frame.match add command -label [msgcat::mc {WCS}] \
	-command MatchFramesWCS
    $ds9(mb).frame.match add command -label [msgcat::mc {Image}] \
	-command {MatchFrames image}
    $ds9(mb).frame.match add command -label [msgcat::mc {Physical}] \
	-command {MatchFrames physical}
    $ds9(mb).frame.match add command -label [msgcat::mc {Amplifier}] \
	-command {MatchFrames amplifier}
    $ds9(mb).frame.match add command -label [msgcat::mc {Detector}] \
	-command {MatchFrames detector}

    DefaultCoordMenu1 $ds9(mb).frame.crosshair crosshair(lock) {}
    $ds9(mb).frame.crosshair insert 1 radiobutton \
	-label [msgcat::mc {None}] -variable crosshair(lock) -value none
    $ds9(mb).frame.crosshair insert 2 separator

    menu $ds9(mb).frame.tile
    $ds9(mb).frame.tile add radiobutton -label [msgcat::mc {Grid}] \
	-variable tile(mode) -value grid -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label [msgcat::mc {Columns}] \
	-variable tile(mode) -value column -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label [msgcat::mc {Rows}] \
	-variable tile(mode) -value row -command DisplayMode
    $ds9(mb).frame.tile add separator
    $ds9(mb).frame.tile add command \
	-label "[msgcat::mc {Tile Parameters}]..." -command TileDialog

    menu $ds9(mb).frame.blink
    $ds9(mb).frame.blink add radiobutton -label ".125 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 125
    $ds9(mb).frame.blink add radiobutton -label ".25 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 250
    $ds9(mb).frame.blink add radiobutton -label ".5 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 500
    $ds9(mb).frame.blink add radiobutton -label "1 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 1000
    $ds9(mb).frame.blink add radiobutton -label "2  [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 2000
    $ds9(mb).frame.blink add radiobutton -label "4 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 4000
    $ds9(mb).frame.blink add radiobutton -label "8 [msgcat::mc {Seconds}]" \
	-variable blink(interval) -value 8000
}

proc PrefsDialogFrame {} {
    global prefs

    set w $prefs(tabs)

    frame $w.frame
    $prefs(tabs) tab configure frame -window $w.frame -fill both

    frame $w.frame.menu -relief ridge -bd 1
    pack $w.frame.menu -side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.frame

    # Default Menu
    set f $w.frame.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Menu}]
    menubutton $f.frame -relief raised -text [msgcat::mc {Frame}] \
	-menu $f.frame.menu

    grid $f.title $f.frame -padx 4 -sticky w

    set m $f.frame.menu
    menu $m
    $m add cascade -label [msgcat::mc {Tile}] \
	-menu $m.tile
    $m add cascade -label [msgcat::mc {Blink Interval}] \
	-menu $m.blink

    menu $m.tile
    $m.tile add radiobutton -label [msgcat::mc {Grid}] \
	-variable prefs(tile,mode) -value grid
    $m.tile add radiobutton -label [msgcat::mc {Columns}] \
	-variable prefs(tile,mode) -value column
    $m.tile add radiobutton -label [msgcat::mc {Rows}] \
	-variable prefs(tile,mode) -value row

    menu $m.blink
    $m.blink add radiobutton -label ".125 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 125
    $m.blink add radiobutton -label ".25 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 250
    $m.blink add radiobutton -label ".5 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 500
    $m.blink add radiobutton -label "1 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 1000
    $m.blink add radiobutton -label "2  [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 2000
    $m.blink add radiobutton -label "4 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 4000
    $m.blink add radiobutton -label "8 [msgcat::mc {Seconds}]" \
	-variable prefs(blink,interval) -value 8000
}

proc FrameButtons {} {
    global ds9

    frame $ds9(buttons).frame
    ButtonButton $ds9(buttons).frame.new \
	[string tolower [msgcat::mc {New}]] CreateFrame
    ButtonButton $ds9(buttons).frame.newrgb \
	[string tolower [msgcat::mc {New RGB}]] CreateRGBFrame
    ButtonButton $ds9(buttons).frame.delete \
	[string tolower [msgcat::mc {Delete}]] DeleteCurrentFrame
    ButtonButton $ds9(buttons).frame.clear \
	[string tolower [msgcat::mc {Clear}]] ClearCurrentFrame
   RadioButton $ds9(buttons).frame.single \
	[string tolower [msgcat::mc {Single}]] \
	ds9(display,user) single DisplayMode
    RadioButton $ds9(buttons).frame.tile \
	[string tolower [msgcat::mc {Tile}]] \
	ds9(display,user) tile DisplayMode
    RadioButton $ds9(buttons).frame.blink \
	[string tolower [msgcat::mc {Blink}]] \
	ds9(display,user) blink DisplayMode
    ButtonButton $ds9(buttons).frame.first \
	[string tolower [msgcat::mc {First}]] FirstFrame
    ButtonButton $ds9(buttons).frame.prev \
	[string tolower [msgcat::mc {Previous}]] PrevFrame
    ButtonButton $ds9(buttons).frame.next \
	[string tolower [msgcat::mc {Next}]] NextFrame
    ButtonButton $ds9(buttons).frame.last \
	[string tolower [msgcat::mc {Last}]] LastFrame
}

proc UpdateFrameMenu {} {
    global ds9
    global current
    global rgb

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateFrameMenu"
    }

    switch -- $ds9(visual) {
	pseudocolor {
	    $ds9(mb).frame entryconfig [msgcat::mc {New Frame RGB}] \
		-state disabled
	    $ds9(buttons).frame.newrgb configure -state disabled
	}
	truecolor {
	    $ds9(mb).frame entryconfig [msgcat::mc {New Frame RGB}] \
		-state normal
	    $ds9(buttons).frame.newrgb configure -state normal
	}
    }

    if {$current(frame) != {}} {
	$ds9(mb).frame entryconfig [msgcat::mc {Delete Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Delete All Frames}] \
	    -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Clear Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Reset Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Refresh Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Single Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Tile Frames}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Frames}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {First Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Previous Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Next Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Last Frame}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Tile}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Interval}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Set Display Size}] \
	    -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Match Frames}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Match Colorbars}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Match Scales}] -state normal
	$ds9(mb).frame entryconfig [msgcat::mc {Lock Crosshairs}] -state normal
	$ds9(mb).frame entryconfig "[msgcat::mc {Data Cube}]..." -state normal

	if {[$current(frame) get type] == {rgb}} {
	    $ds9(mb).frame entryconfig "[msgcat::mc {RGB}]..." -state normal
	} else {
	    $ds9(mb).frame entryconfig "[msgcat::mc {RGB}]..." -state disabled
	}

	$ds9(buttons).frame.delete configure -state normal
	$ds9(buttons).frame.clear configure -state normal
	$ds9(buttons).frame.single configure -state normal
	$ds9(buttons).frame.tile configure -state normal
	$ds9(buttons).frame.blink configure -state normal
	$ds9(buttons).frame.first configure -state normal
	$ds9(buttons).frame.prev configure -state normal
	$ds9(buttons).frame.next configure -state normal
	$ds9(buttons).frame.last configure -state normal
    } else {
	$ds9(mb).frame entryconfig [msgcat::mc {Delete Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Delete All Frames}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Clear Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Reset Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Refresh Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Single Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Tile Frames}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Frames}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {First Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Previous Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Next Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Last Frame}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Tile}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Blink Interval}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Set Display Size}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Match Frames}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Match Colorbars}] \
	    -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Match Scales}] -state disabled
	$ds9(mb).frame entryconfig [msgcat::mc {Lock Crosshairs}] \
	    -state disabled
	$ds9(mb).frame entryconfig "[msgcat::mc {Data Cube}]..." \
	    -state disabled
	$ds9(mb).frame entryconfig "[msgcat::mc {RGB}]..." -state disabled

	$ds9(buttons).frame.delete configure -state disabled
	$ds9(buttons).frame.clear configure -state disabled
	$ds9(buttons).frame.single configure -state disabled
	$ds9(buttons).frame.tile configure -state disabled
	$ds9(buttons).frame.blink configure -state disabled
	$ds9(buttons).frame.first configure -state disabled
	$ds9(buttons).frame.prev configure -state disabled
	$ds9(buttons).frame.next configure -state disabled
	$ds9(buttons).frame.last configure -state disabled
    }
}

# Frame Menu Delete
proc UpdateFrameMenuItems {} {
    global ds9

    if {[$ds9(mb).frame index end] > $ds9(menu,size,frame)} {
	$ds9(mb).frame delete [expr $ds9(menu,size,frame)+1] end
    }

    if {[$ds9(mb).frame.active index end] > $ds9(menu,size,frame,active)} {
	$ds9(mb).frame.active delete [expr $ds9(menu,size,frame,active)+1] end
    }

    set cnt $ds9(menu,size,frame)
    foreach f $ds9(frames) {
	$ds9(mb).frame add radiobutton -label $f \
	    -variable ds9(next) -value $f -command GotoFrame

	# wrap if needed
	incr cnt
	if {$cnt>=[expr $ds9(menu,size,wrap)+20]} {
	    set cnt 4
	    $ds9(mb).frame entryconfig $f -columnbreak 1
	}
    }

    set cnt $ds9(menu,size,frame,active)
    foreach f $ds9(frames) {
	$ds9(mb).frame.active add checkbutton -label $f \
	    -variable active($f) -command UpdateActiveFrames

	# wrap if needed
	incr cnt
	if {$cnt>=$ds9(menu,size,wrap)} {
	    set cnt 1
	    $ds9(mb).frame.active entryconfig $f -columnbreak 1
	}
    }
}

