#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc HelpMenu {varname} {
    upvar $varname var

    $var add cascade -label [msgcat::mc {Help}] -menu $var.help

    menu $var.help
    $var.help add command -label [msgcat::mc {Reference Manual}]\
	-command HelpRef
    $var.help add command -label [msgcat::mc {Keyboard Shortcuts}] \
	-command HelpKeyboard
    $var.help add separator
    $var.help add command -label [msgcat::mc {FAQ}] \
	-command HelpFAQ
    $var.help add command -label [msgcat::mc {New Features}] \
	-command HelpNew
    $var.help add command -label [msgcat::mc {Known Issues}] \
	-command HelpIssue
    $var.help add command -label [msgcat::mc {Release Notes}] \
	-command HelpRelease
    $var.help add command -label [msgcat::mc {Help Desk}] \
	-command HelpDesk
    $var.help add separator
    $var.help add command -label [msgcat::mc {Acknowledgment}] \
	-command HelpAck
    $var.help add command -label [msgcat::mc {DS9 Home Page}] \
	-command HelpHome
}

proc HelpButtons {} {
    global ds9
    global help

    frame $ds9(buttons).help
    ButtonButton $ds9(buttons).help.ref \
	[string tolower [msgcat::mc {Reference}]] HelpRef
    ButtonButton $ds9(buttons).help.keyboard \
	[string tolower [msgcat::mc {Keyboard}]] HelpKeyboard
    ButtonButton $ds9(buttons).help.release \
	[string tolower [msgcat::mc {Release}]] HelpRelease
    ButtonButton $ds9(buttons).help.desk \
	[string tolower [msgcat::mc {Help Desk}]] HelpDesk
    ButtonButton $ds9(buttons).help.ack \
	[string tolower [msgcat::mc {Acknowledgment}]] HelpAck
    ButtonButton $ds9(buttons).help.home \
	[string tolower [msgcat::mc {Home}]] HelpHome
}

