#  Copyright (C) 1999-2008
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc RegionMenu {} {
    global ds9
    global marker

    menu $ds9(mb).region
    $ds9(mb).region add checkbutton -label [msgcat::mc {Show Regions}] \
	-variable marker(show) -command MarkerShow
    $ds9(mb).region add checkbutton -label [msgcat::mc {Show Regions Text}] \
	-variable marker(show,text) -command MarkerShowText
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "[msgcat::mc {Get Information}]..." \
	-command MarkerInfo
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {Shape}] \
	-menu $ds9(mb).region.shape
    $ds9(mb).region add cascade -label [msgcat::mc {Instrument FOV}] \
	-menu $ds9(mb).region.template
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {Color}] \
	-menu $ds9(mb).region.color
    $ds9(mb).region add cascade -label [msgcat::mc {Width}] \
	-menu $ds9(mb).region.width
    $ds9(mb).region add cascade -label [msgcat::mc {Properties}] \
	-menu $ds9(mb).region.properties
    $ds9(mb).region add cascade -label [msgcat::mc {Font}] \
	-menu $ds9(mb).region.font
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Move to Front}] \
	-command MarkerFront
    $ds9(mb).region add command -label [msgcat::mc {Move to Back}] \
	-command MarkerBack
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Select All}] \
	-command MarkerSelectAll -accelerator "${ds9(ctrl)}A"
    $ds9(mb).region add command -label [msgcat::mc {Select None}] \
	-command MarkerUnselectAll
    $ds9(mb).region add command -label [msgcat::mc {Invert Selection}] \
	-command MarkerSelectInvert
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Delete Selected Regions}] \
	-command MarkerDeleteSelect
    $ds9(mb).region add command -label [msgcat::mc {Delete All Regions}] \
	-command MarkerDeleteAllMenu
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {New Group}] \
	-command GroupCreate
    $ds9(mb).region add command -label "[msgcat::mc {Groups}]..." \
	-command GroupDialog
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Create Composite Region}] \
	-command CompositeCreate
    $ds9(mb).region add command \
	-label [msgcat::mc {Dissolve Composite Region}] \
	-command CompositeDelete
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "[msgcat::mc {Load Template}]..." \
	-command OpenTemplateMarker
    $ds9(mb).region add command -label "[msgcat::mc {Save as Template}]..." \
	-command SaveAsTemplateMarker
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {List Regions}] \
	-command MarkerDisplay
    $ds9(mb).region add command -label "[msgcat::mc {Load Regions}]..." \
	-command MarkerOpen
    $ds9(mb).region add command -label "[msgcat::mc {Save Regions}]..." \
	-command MarkerSave
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {File Format}] \
	-menu $ds9(mb).region.format
    $ds9(mb).region add cascade -label [msgcat::mc {File Coordinate System}] \
	-menu $ds9(mb).region.coord

    menu $ds9(mb).region.shape
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle}] \
	-variable marker(shape) -value circle
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Ellipse}] \
	-variable marker(shape) -value ellipse
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box}] \
	-variable marker(shape) -value box
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Polygon}] \
	-variable marker(shape) -value polygon
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Line}] \
	-variable marker(shape) -value line
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Vector}] \
	-variable marker(shape) -value vector
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Text}] \
	-variable marker(shape) -value text
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Ruler}] \
	-variable marker(shape) -value ruler
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Compass}] \
	-variable marker(shape) -value compass
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Projection}] \
	-variable marker(shape) -value projection
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Annulus}] \
	-variable marker(shape) -value annulus
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Annulus}] \
	-variable marker(shape) -value ellipseannulus
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Annulus}] \
	-variable marker(shape) -value boxannulus
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Panda}] \
	-variable marker(shape) -value panda
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Panda}]\
	-variable marker(shape) -value epanda
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Panda}] \
	-variable marker(shape) -value bpanda
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle Point}] \
	-variable marker(shape) -value {circle point} 
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Point}] \
	-variable marker(shape) -value {box point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Diamond Point}] \
	-variable marker(shape) -value {diamond point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Cross Point}] \
	-variable marker(shape) -value {cross point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {X Point}] \
	-variable marker(shape) -value {x point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Arrow Point}] \
	-variable marker(shape) -value {arrow point} 
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {BoxCircle Point}] \
	-variable marker(shape) -value {boxcircle point}

    CreateTemplateMenu
    DefaultColorMenu $ds9(mb).region.color marker(color) MarkerColor
    DefaultWidthMenu $ds9(mb).region.width marker(width) MarkerWidth

    menu $ds9(mb).region.properties
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Edit}] \
	-variable marker(edit) -command {MarkerProp edit}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Move}] \
	-variable marker(move) -command {MarkerProp move}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Rotate}] \
	-variable marker(rotate) -command {MarkerProp rotate}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Delete}] \
	-variable marker(delete) -command {MarkerProp delete}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Fixed in Size}] \
	-variable marker(fixed) -command {MarkerProp fixed}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Include}] \
	-variable marker(include) -value 1 -command {MarkerProp include}
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Exclude}] \
	-variable marker(include) -value 0 -command {MarkerProp include}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Source}] \
	-variable marker(source) -value 1 -command {MarkerProp source}
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Background}] \
	-variable marker(source) -value 0 -command {MarkerProp source}

    DefaultFontMenu $ds9(mb).region.font marker(font) marker(font,size) \
	marker(font,style) MarkerFont

    menu $ds9(mb).region.format
    $ds9(mb).region.format add radiobutton -label {DS9/Funtools} \
	-variable marker(format) -value ds9 -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {Ciao} \
	-variable marker(format) -value ciao -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {SAOtng} \
	-variable marker(format) -value saotng -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {SAOimage} \
	-variable marker(format) -value saoimage \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {IRAF PROS} \
	-variable marker(format) -value pros -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {X Y} \
	-variable marker(format) -value xy -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add separator
    $ds9(mb).region.format add checkbutton -label [msgcat::mc {Strip Output}] \
	-variable marker(strip)
    $ds9(mb).region.format add checkbutton -label [msgcat::mc {List WCS}] \
	-variable marker(wcs)

    DefaultCoordMenu $ds9(mb).region.coord marker(system) \
	marker(sky) marker(skyformat) UpdateMarkerFormatMenu

    # Bindings
    event add <<SelectAll>> <${ds9(ctrl)}a>
    bind $ds9(top) <<SelectAll>> MarkerSelectAll
}

proc PrefsDialogRegion {} {
    global prefs

    set w $prefs(tabs)

    frame $w.region
    $prefs(tabs) tab configure region -window $w.region -fill both

    frame $w.region.menu -relief ridge -bd 1
    frame $w.region.dialog -relief ridge -bd 1
    frame $w.region.circle -relief ridge -bd 1
    frame $w.region.ellipse -relief ridge -bd 1
    frame $w.region.box -relief ridge -bd 1
    frame $w.region.point -relief ridge -bd 1
    frame $w.region.projection -relief ridge -bd 1
    pack $w.region.menu $w.region.dialog $w.region.circle $w.region.ellipse \
	$w.region.box $w.region.point $w.region.projection \
	-side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.region

    # Default Menu
    set f $w.region.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Menu}]
    menubutton $f.region -relief raised -text [msgcat::mc {Region}] \
	-menu $f.region.menu

    grid $f.title $f.region -padx 4 -sticky w

    set m $f.region.menu
    menu $m
    $m add cascade -label [msgcat::mc {Shape}] -menu $m.shape
    $m add cascade -label [msgcat::mc {Color}] -menu $m.color
    $m add cascade -label [msgcat::mc {Width}] -menu $m.width
    $m add cascade -label [msgcat::mc {Properties}] -menu $m.properties
    $m add cascade -label [msgcat::mc {Font}] -menu $m.font
    $m add separator
    $m add cascade -label [msgcat::mc {File Format}] -menu $m.format
    $m add cascade -label [msgcat::mc {File Coordinate System}] -menu $m.coord

    menu $m.shape
    $m.shape add radiobutton -label [msgcat::mc {Circle}] \
	-variable prefs(marker,shape) -value circle
    $m.shape add radiobutton -label [msgcat::mc {Ellipse}] \
	-variable prefs(marker,shape) -value ellipse
    $m.shape add radiobutton -label [msgcat::mc {Box}] \
	-variable prefs(marker,shape) -value box
    $m.shape add radiobutton -label [msgcat::mc {Polygon}] \
	-variable prefs(marker,shape) -value polygon
    $m.shape add radiobutton -label [msgcat::mc {Line}] \
	-variable prefs(marker,shape) -value line
    $m.shape add radiobutton -label [msgcat::mc {Vector}] \
	-variable prefs(marker,shape) -value vector
    $m.shape add radiobutton -label [msgcat::mc {Text}] \
	-variable prefs(marker,shape) -value text
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Ruler}] \
	-variable prefs(marker,shape) -value ruler
    $m.shape add radiobutton -label [msgcat::mc {Compass}] \
	-variable prefs(marker,shape) -value compass
    $m.shape add radiobutton -label [msgcat::mc {Projection}] \
	-variable prefs(marker,shape) -value projection
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Annulus}] \
	-variable prefs(marker,shape) -value annulus
    $m.shape add radiobutton -label [msgcat::mc {Elliptical Annulus}] \
	-variable prefs(marker,shape) -value ellipseannulus
    $m.shape add radiobutton -label [msgcat::mc {Box Annulus}] \
	-variable prefs(marker,shape) -value boxannulus
    $m.shape add radiobutton -label [msgcat::mc {Panda}] \
	-variable prefs(marker,shape) -value panda
    $m.shape add radiobutton -label [msgcat::mc {Elliptical Panda}] \
	-variable prefs(marker,shape) -value epanda
    $m.shape add radiobutton -label [msgcat::mc {Box Panda}] \
	-variable prefs(marker,shape) -value bpanda
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Circle Point}] \
	-variable prefs(marker,shape) -value {circle point}
    $m.shape add radiobutton -label [msgcat::mc {Box Point}] \
	-variable prefs(marker,shape) -value {box point} 
    $m.shape add radiobutton -label [msgcat::mc {Diamond Point}] \
	-variable prefs(marker,shape) -value {diamond point}
    $m.shape add radiobutton -label [msgcat::mc {Cross Point}] \
	-variable prefs(marker,shape) -value {cross point}
    $m.shape add radiobutton -label [msgcat::mc {X Point}] \
	-variable prefs(marker,shape) -value {x point}
    $m.shape add radiobutton -label [msgcat::mc {Arrow Point}] \
	-variable prefs(marker,shape) -value {arrow point}
    $m.shape add radiobutton -label [msgcat::mc {BoxCircle Point}] \
	-variable prefs(marker,shape) -value {boxcircle point}

    DefaultColorMenu $m.color prefs(marker,color) {}
    DefaultWidthMenu $m.width prefs(marker,width) {}

    menu $m.properties
    $m.properties add checkbutton -label [msgcat::mc {Can Edit}] \
	-variable prefs(marker,edit)
    $m.properties add checkbutton -label [msgcat::mc {Can Move}] \
	-variable prefs(marker,move)
    $m.properties add checkbutton -label [msgcat::mc {Can Rotate}] \
	-variable prefs(marker,rotate)
    $m.properties add checkbutton -label [msgcat::mc {Can Delete}] \
	-variable prefs(marker,delete)
    $m.properties add checkbutton -label [msgcat::mc {Fixed in Size}] \
	-variable prefs(marker,fixed)

    $m.properties add separator
    $m.properties add radiobutton -label [msgcat::mc {Include}] \
	-variable prefs(marker,include) -value 1
    $m.properties add radiobutton -label [msgcat::mc {Exclude}] \
	-variable prefs(marker,include) -value 0
    $m.properties add separator
    $m.properties add radiobutton -label [msgcat::mc {Source}] \
	-variable prefs(marker,source) -value 1
    $m.properties add radiobutton -label [msgcat::mc {Background}] \
	-variable prefs(marker,source) -value 0

    DefaultFontMenu $m.font \
	prefs(marker,font) prefs(marker,font,size) prefs(marker,font,style) \
	{}

    menu $m.format
    $m.format add radiobutton -label {DS9/Funtools} \
	-variable prefs(marker,format) -value ds9 -command PrefsMarkerFormat
    $m.format add radiobutton -label {Ciao} \
	-variable prefs(marker,format) -value ciao -command PrefsMarkerFormat
    $m.format add radiobutton -label {SAOtng} \
	-variable prefs(marker,format) -value saotng -command PrefsMarkerFormat
    $m.format add radiobutton -label {SAOimage} \
	-variable prefs(marker,format) -value saoimage \
	-command PrefsMarkerFormat
    $m.format add radiobutton -label {IRAF PROS} \
	-variable prefs(marker,format) -value pros -command PrefsMarkerFormat
    $m.format add radiobutton -label {X Y} \
	-variable prefs(marker,format) -value xy -command PrefsMarkerFormat
    $m.format add separator
    $m.format add checkbutton -label [msgcat::mc {Strip Output}] \
	-variable prefs(marker,strip)
    $m.format add checkbutton -label [msgcat::mc {List WCS}] \
	-variable prefs(marker,wcs)

    DefaultCoordMenu $m.coord \
	prefs(marker,system) prefs(marker,sky) prefs(marker,skyformat) {}

    # Default Dialog
    set f $w.region.dialog.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Dialog}]
    menubutton $f.sys -relief raised \
	-text [msgcat::mc {Coordinate System}] -menu $f.sys.menu
    menubutton $f.dist -relief raised \
	-text [msgcat::mc {Distance System}] -menu $f.dist.menu

    grid $f.title -padx 4 -sticky w
    grid $f.sys $f.dist -padx 4 -sticky w

    DefaultCoordMenu $f.sys.menu \
	marker(dialog,system) marker(dialog,sky) marker(dialog,skyformat) {}

    DefaultDistMenu $f.dist.menu \
	marker(dialog,dist,system) marker(dialog,dist,format) {}

    # Default Circle
    set f $w.region.circle.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Circle}]
    label $f.title -text [msgcat::mc {Radius}]
    entry $f.radius -textvariable marker(circle,radius) -width 10
    label $f.unit -text [msgcat::mc {Image}]
   
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius $f.unit -padx 4 -sticky w

    # Default Ellipse
    set f $w.region.ellipse.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Ellipse}]
    label $f.title -text "Radius 1"
    entry $f.radius1 -textvariable marker(ellipse,radius1) -width 10 
    label $f.unit -text [msgcat::mc {Image}]
    
    label $f.title2 -text "Radius 2"
    entry $f.radius2 -textvariable marker(ellipse,radius2) -width 10 
    label $f.unit2 -text [msgcat::mc {Image}]

    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius1 $f.unit -padx 4 -pady 1 -sticky w
    grid $f.title2 $f.radius2 $f.unit2 -padx 4 -pady 1 -sticky w
    
    # Default Box
    set f $w.region.box.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Box}]
    label $f.title -text "Size 1"
    entry $f.radius1 -textvariable marker(box,radius1) -width 10 
    label $f.unit -text [msgcat::mc {Image}]
    
    label $f.title2 -text "Size 2"
    entry $f.radius2 -textvariable marker(box,radius2) -width 10 
    label $f.unit2 -text [msgcat::mc {Image}]

    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius1 $f.unit -padx 4 -pady 1 -sticky w
    grid $f.title2 $f.radius2 $f.unit2 -padx 4 -pady 1 -sticky w

    # Default Point
    set f $w.region.point.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Point}]
    label $f.title -text [msgcat::mc {Size}]
    entry $f.size -textvariable marker(point,size) -width 10
    label $f.unit -text [msgcat::mc {Pixels}]
    
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.size $f.unit -padx 4 -sticky w

    # Default Projection
    set f $w.region.projection.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Projection}]
    label $f.title -text [msgcat::mc {Thickness}]
    entry $f.thick -textvariable marker(projection,thick) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.thick $f.unit -padx 4 -sticky w
}

proc PrefsDialogAnnulus {} {
    global prefs

    set w $prefs(tabs)

    frame $w.annulus
    $prefs(tabs) tab configure annulus -window $w.annulus -fill both

    frame $w.annulus.annulus -relief ridge -bd 1
    frame $w.annulus.ellipseannulus -relief ridge -bd 1
    frame $w.annulus.boxannulus -relief ridge -bd 1
    pack $w.annulus.annulus $w.annulus.ellipseannulus $w.annulus.boxannulus \
	-side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.annulus

    # Default Annulus
    set f $w.annulus.annulus.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Annulus}]
    label $f.innerTitle -text [msgcat::mc {Inner}]
    label $f.outerTitle -text [msgcat::mc {Outer}]
    label $f.radiusTitle -text [msgcat::mc {Radius}]
    entry $f.inner -textvariable marker(annulus,inner) -width 10
    entry $f.outer -textvariable marker(annulus,outer) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable marker(annulus,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.innerTitle $f.outerTitle -padx 4 -sticky w
    grid $f.radiusTitle $f.inner $f.outer $f.unit -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    # Default Ellipse Annulus
    set f $w.annulus.ellipseannulus.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Elliptical Annulus}]
    label $f.majorTitle -text [msgcat::mc {Major}]
    label $f.minorTitle -text [msgcat::mc {Major}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable marker(ellipseannulus,radius1) -width 10 	
    entry $f.radius2 -textvariable marker(ellipseannulus,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable marker(ellipseannulus,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable marker(ellipseannulus,annuli) -width 10 
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit \
	-padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    # Default Box Annulus
    set f $w.annulus.boxannulus.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Box Annulus}]
    label $f.majorTitle -text [msgcat::mc {Width}]
    label $f.minorTitle -text [msgcat::mc {Height}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable marker(boxannulus,radius1) -width 10 	
    entry $f.radius2 -textvariable marker(boxannulus,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable marker(boxannulus,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable marker(boxannulus,annuli) -width 10 
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit \
	-padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

}
proc PrefsDialogPanda {} {
    global prefs

    set w $prefs(tabs)

    frame $w.panda
    $prefs(tabs) tab configure panda -window $w.panda -fill both

    frame $w.panda.panda -relief ridge -bd 1
    frame $w.panda.epanda -relief ridge -bd 1
    frame $w.panda.bpanda -relief ridge -bd 1
    pack $w.panda.panda $w.panda.epanda $w.panda.bpanda \
	-side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.panda

    # Default Panda
    set f $w.panda.panda.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Panda}]
    label $f.innerTitle -text [msgcat::mc {Inner}]
    label $f.outerTitle -text [msgcat::mc {Outer}]
    label $f.radiusTitle -text [msgcat::mc {Radius}]
    entry $f.inner -textvariable marker(panda,inner) -width 10
    entry $f.outer -textvariable marker(panda,outer) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable marker(panda,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.innerTitle $f.outerTitle -padx 4 -sticky w
    grid $f.radiusTitle $f.inner $f.outer $f.unit -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    label $f.ang1Title -text [msgcat::mc {Start}]
    label $f.ang2Title -text [msgcat::mc {Stop}]
    label $f.angTitle -text [msgcat::mc {Angles}]
    entry $f.ang1 -textvariable marker(panda,ang1) -width 10
    entry $f.ang2 -textvariable marker(panda,ang2) -width 10
    label $f.angunit -text [msgcat::mc {Degrees}]
    label $f.angnumTitle -text [msgcat::mc {Number}]
    entry $f.angnum -textvariable marker(panda,angnum) -width 10
    
    grid x $f.ang1Title $f.ang2Title -padx 4 -sticky w
    grid $f.angTitle $f.ang1 $f.ang2 $f.angunit -padx 4 -sticky w
    grid $f.angnumTitle $f.angnum -padx 4 -sticky w

    # Default Elliptical Panda
    set f $w.panda.epanda.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Elliptical Panda}]

    label $f.majorTitle -text [msgcat::mc {Major}]
    label $f.minorTitle -text [msgcat::mc {Minor}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable marker(epanda,radius1) -width 10 	
    entry $f.radius2 -textvariable marker(epanda,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable marker(epanda,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable marker(epanda,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit -padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    label $f.ang1Title -text [msgcat::mc {Start}]
    label $f.ang2Title -text [msgcat::mc {Stop}]
    label $f.angTitle -text [msgcat::mc {Angles}]
    entry $f.ang1 -textvariable marker(epanda,ang1) -width 10
    entry $f.ang2 -textvariable marker(epanda,ang2) -width 10
    label $f.angunit -text [msgcat::mc {Degrees}]
    label $f.angnumTitle -text [msgcat::mc {Number}]
    entry $f.angnum -textvariable marker(epanda,angnum) -width 10
    
    grid x $f.ang1Title $f.ang2Title -padx 4 -sticky w
    grid $f.angTitle $f.ang1 $f.ang2 $f.angunit -padx 4 -sticky w
    grid $f.angnumTitle $f.angnum -padx 4 -sticky w

    # Default Box Panda
    set f $w.panda.bpanda.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Elliptical Panda}]

    label $f.majorTitle -text [msgcat::mc {Major}]
    label $f.minorTitle -text [msgcat::mc {Minor}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable marker(bpanda,radius1) -width 10 	
    entry $f.radius2 -textvariable marker(bpanda,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable marker(bpanda,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable marker(bpanda,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit -padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    label $f.ang1Title -text [msgcat::mc {Start}]
    label $f.ang2Title -text [msgcat::mc {Stop}]
    label $f.angTitle -text [msgcat::mc {Angles}]
    entry $f.ang1 -textvariable marker(bpanda,ang1) -width 10
    entry $f.ang2 -textvariable marker(bpanda,ang2) -width 10
    label $f.angunit -text [msgcat::mc {Degrees}]
    label $f.angnumTitle -text [msgcat::mc {Number}]
    entry $f.angnum -textvariable marker(bpanda,angnum) -width 10
    
    grid x $f.ang1Title $f.ang2Title -padx 4 -sticky w
    grid $f.angTitle $f.ang1 $f.ang2 $f.angunit -padx 4 -sticky w
    grid $f.angnumTitle $f.angnum -padx 4 -sticky w
}

proc RegionButtons {} {
    global ds9

    frame $ds9(buttons).region1
    ButtonButton $ds9(buttons).region1.info \
	[string tolower [msgcat::mc {Information}]] MarkerInfo
    ButtonButton $ds9(buttons).region1.front \
	[string tolower [msgcat::mc {Front}]] MarkerFront
    ButtonButton $ds9(buttons).region1.back \
	[string tolower [msgcat::mc {Back}]] MarkerBack
    ButtonButton $ds9(buttons).region1.all \
	[string tolower [msgcat::mc {All}]] MarkerSelectAll
    ButtonButton $ds9(buttons).region1.none \
	[string tolower [msgcat::mc {None}]] MarkerUnselectAll
    ButtonButton $ds9(buttons).region1.delete \
	[string tolower [msgcat::mc {Delete}]] MarkerDeleteSelect
    ButtonButton $ds9(buttons).region1.list \
	[string tolower [msgcat::mc {List}]] MarkerDisplay
    ButtonButton $ds9(buttons).region1.load \
	[string tolower [msgcat::mc {Load}]] MarkerOpen
    ButtonButton $ds9(buttons).region1.save \
	[string tolower [msgcat::mc {Save}]] MarkerSave
    RadioButton $ds9(buttons).region1.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region2 MajorButton
    
    frame $ds9(buttons).region2
    RadioButton $ds9(buttons).region2.circle \
	[string tolower [msgcat::mc {Circle}]] \
	marker(shape) circle {}
    RadioButton $ds9(buttons).region2.ellipse \
	[string tolower [msgcat::mc {Ellipse}]] \
	marker(shape) ellipse {}
    RadioButton $ds9(buttons).region2.box \
	[string tolower [msgcat::mc {Box}]] \
	marker(shape) box {}
    RadioButton $ds9(buttons).region2.polygon \
	[string tolower [msgcat::mc {Polygon}]] \
	marker(shape) polygon {}
    RadioButton $ds9(buttons).region2.line \
	[string tolower [msgcat::mc {Line}]] \
	marker(shape) line {}
    RadioButton $ds9(buttons).region2.vector \
	[string tolower [msgcat::mc {Vector}]] \
	marker(shape) vector {}
    RadioButton $ds9(buttons).region2.text \
	[string tolower [msgcat::mc {Text}]] \
	marker(shape) text {}
    RadioButton $ds9(buttons).region2.point \
	[string tolower [msgcat::mc {Point}]] \
	marker(shape) {circle point} {}
    RadioButton $ds9(buttons).region2.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region3 MajorButton

    frame $ds9(buttons).region3
    RadioButton $ds9(buttons).region3.ruler \
	[string tolower [msgcat::mc {Ruler}]] \
	marker(shape) ruler {}
    RadioButton $ds9(buttons).region3.compass \
	[string tolower [msgcat::mc {Compass}]] \
	marker(shape) compass {}
    RadioButton $ds9(buttons).region3.projection \
	[string tolower [msgcat::mc {Projection}]] \
	marker(shape) projection {}
    RadioButton $ds9(buttons).region3.annulus \
	[string tolower [msgcat::mc {Annulus}]] \
	marker(shape) annulus {}
    RadioButton $ds9(buttons).region3.ellispsannulus \
	[string tolower [msgcat::mc {Elliptical Annulus}]] \
	marker(shape) ellipseannulus {}
    RadioButton $ds9(buttons).region3.boxannulus \
	[string tolower [msgcat::mc {Box Annulus}]] \
	marker(shape) boxannulus {}
    RadioButton $ds9(buttons).region3.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region4 MajorButton

    frame $ds9(buttons).region4
    RadioButton $ds9(buttons).region4.panda \
	[string tolower [msgcat::mc {Panda}]] \
	marker(shape) panda {}
    RadioButton $ds9(buttons).region4.epanda \
	[string tolower [msgcat::mc {Ellipse Panda}]] \
	marker(shape) epanda {}
    RadioButton $ds9(buttons).region4.bpanda \
	[string tolower [msgcat::mc {Box Panda}]] \
	marker(shape) bpanda {}
    RadioButton $ds9(buttons).region4.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region1 MajorButton
}

proc UpdateRegionMenu {} {
    global ds9
    global current
    global marker

    if {$current(frame) != {}} {
	set marker(show) [$current(frame) get marker show]
	set marker(show,text) [$current(frame) get marker show text]
	set marker(preserve) [$current(frame) get marker preserve]

	switch -- $ds9(mode) {
	    pointer {
		if {[$current(frame) get marker select number] == 1} {
		    set marker(color) [$current(frame) get marker color]
		    set marker(width) [$current(frame) get marker width]
		    set marker(edit) [$current(frame) get marker property edit]
		    set marker(move) [$current(frame) get marker property move]
		    set marker(rotate) \
			[$current(frame) get marker property rotate]
		    set marker(delete) \
			[$current(frame) get marker property delete]
		    set marker(fixed) \
			[$current(frame) get marker property fixed]
		    set marker(include) \
			[$current(frame) get marker property include]
		    set marker(source) \
			[$current(frame) get marker property source]

		    set f [$current(frame) get marker font]

		    set marker(font) [lindex $f 0]
		    set marker(font,size) [lindex $f 1]
		    set marker(font,style) [lindex $f 2]
		}
	    }
	}
    }

    UpdateMarkerFormatMenu
}

